<template>
	<v-container class="sampling-collection-show flex-grow-1">
		<v-card class="my-4 mx-auto d-block" rounded="lg" max-width="50em">
			<div class="text-center py-6" v-if="isLoading">
				<v-progress-circular indeterminate color="primary" />
			</div>
			<div class="d-flex justify-center align-center py-6 mx-2" v-if="hasError">
				<v-icon color="error">mdi-alert-circle</v-icon>
				<v-divider vertical class="mx-2" />
				<p class="mt-0 mb-0">There was an error loading resources. Please refresh.</p>
			</div>
			<v-card-text v-if="isLoaded && !samplingCollection">Sampling collection not found.</v-card-text>
			<div v-if="isLoaded && samplingCollection">
				<v-card-text>
					<div v-if="field"><span class="font-weight-medium">Field:</span> {{ field.name }}</div>
					<div v-if="samplingCollectionStatus">
						<span class="font-weight-medium">Status:</span>
						{{ samplingCollectionStatus === 'DRAFT' ? 'In Progress' : 'Submitted' }}
					</div>
					<div>
						<span class="font-weight-medium">Created on:</span>
						{{ new Date(samplingCollection.dateCreated).toLocaleString() }}
					</div>
					<div>
						<span class="font-weight-medium">Last modified:</span>
						{{ new Date(samplingCollection.dateModified).toLocaleString() }}
					</div>
					<div class="mt-1">
						<v-icon small class="mr-1"> mdi-triangle </v-icon>
						{{ progressText }} locations collected
					</div>
				</v-card-text>
				<div class="d-flex justify-center align-center mx-2 pb-4" v-if="!locationCollection">
					<v-icon color="warning">mdi-alert-circle</v-icon>
					<v-divider vertical class="mx-2" />
					<div class="subtitle-2">
						{{ ORPHANED_DRAFT_SAMPLING_COLLECTION_INFO }}
					</div>
				</div>
				<v-card-actions class="pb-2 pt-0">
					<v-btn
						v-if="samplingCollectionStatus === 'DRAFT' || samplingCollectionStatus === 'SUBMITTED'"
						:to="editPath"
						class="px-4"
						rounded
						color="primary"
						:disabled="!locationCollection"
					>
						Edit
					</v-btn>
					<download-lab-inventory-button
						v-if="samplingCollectionStatus === 'SUBMITTED'"
						:sampling-collection-ids="[id]"
					/>
					<v-spacer />
					<sampling-collection-delete v-if="samplingCollectionStatus === 'DRAFT'" :id="id" :redirect="true" />
				</v-card-actions>
			</div>
		</v-card>
	</v-container>
</template>

<script lang="ts">
import { computed, ComputedRef, defineComponent } from '@vue/composition-api';
import { useAllResources } from '@/store/modules/resources';
import { useAllSamplingCollections } from '@/store/modules/samplingCollections';
import { useAllSamplings } from '@/store/modules/samplings';
import { Field, LocationCollection, Sampling, SamplingCollection, SamplingCollectionStatus } from '@/store/types';
import { ORPHANED_DRAFT_SAMPLING_COLLECTION_INFO } from '../../constants';
import DownloadLabInventoryButton from './DownloadLabInventoryButton.vue';
import SamplingCollectionDelete from './SamplingCollectionDelete.vue';

export default defineComponent({
	props: {
		id: {
			type: String,
			required: true,
		},
	},
	components: {
		DownloadLabInventoryButton,
		SamplingCollectionDelete,
	},
	setup(props, { root }) {
		const editPath = `/sampling-collection/${props.id}/edit`;

		const {
			isLoaded: resourcesAreLoaded,
			isLoading: resourcesAreLoading,
			hasError: resourcesHaveError,
			samplingCollections: submittedSamplingCollections,
		} = useAllResources(root.$store);

		const {
			isLoaded: draftsAreLoaded,
			isLoading: draftsAreLoading,
			hasError: draftsHaveError,
			samplingCollections: draftSamplingCollections,
		} = useAllSamplingCollections(root.$store);

		const {
			isLoaded: samplingsAreLoaded,
			isLoading: samplingsAreLoading,
			hasError: samplingsHaveError,
		} = useAllSamplings(root.$store);

		const isLoaded = computed(() => resourcesAreLoaded.value && draftsAreLoaded.value && samplingsAreLoaded.value);

		const isLoading = computed(() =>
			[draftsAreLoading.value, samplingsAreLoading.value, resourcesAreLoading.value].some(Boolean)
		);

		const hasError = computed(() =>
			[draftsHaveError.value, samplingsHaveError.value, resourcesHaveError.value].some(Boolean)
		);

		const samplingCollectionStatus: ComputedRef<SamplingCollectionStatus> = computed(() =>
			root.$store.getters.getSamplingCollectionStatusBySamplingCollectionId(props.id)
		);

		const samplingCollection: ComputedRef<SamplingCollection | undefined> = computed(
			() =>
				submittedSamplingCollections.value?.find(({ id }: SamplingCollection) => id === props.id) ||
				draftSamplingCollections.value?.find(({ id }: SamplingCollection) => id === props.id)
		);

		const samplings: ComputedRef<Sampling[]> = computed(() => {
			if (samplingCollectionStatus.value === 'SUBMITTED') {
				return root.$store.getters['resources/getSamplingsBySamplingCollectionId'](props.id);
			} else if (samplingCollectionStatus.value === 'DRAFT') {
				return root.$store.getters['samplings/getBySamplingCollectionId'](props.id);
			}
			return [];
		});

		const locationCollection: ComputedRef<LocationCollection | undefined> = computed(() =>
			root.$store.getters['resources/getLocationCollectionById'](samplingCollection.value?.object)
		);

		const locationsCount: ComputedRef<number> = computed(() => locationCollection.value?.features?.length ?? 0);

		const progressText: ComputedRef<string> = computed(() =>
			isLoaded.value
				? locationCollection.value
					? `${samplings.value.length} / ${locationsCount.value}`
					: `${samplings.value.length}`
				: ''
		);

		const field: ComputedRef<Field | undefined> = computed(() =>
			root.$store.getters['resources/getFieldById'](samplingCollection.value?.featureOfInterest)
		);

		return {
			editPath,
			isLoaded,
			isLoading,
			hasError,
			locationCollection,
			samplingCollection,
			samplingCollectionStatus,
			field,
			progressText,
			ORPHANED_DRAFT_SAMPLING_COLLECTION_INFO,
		};
	},
});
</script>

<style></style>
